import 'package:flutter/foundation.dart';

/// Represents a simple `User` in the OpenID-Connect terms for authentication
/// at the S3I-IdentityProvider.
@immutable
class UserIdentity {
  /// Creates a [UserIdentity] with the given [username] and the [password] which
  /// could be empty if the user is a public client.
  const UserIdentity(this.username, {this.password = ''});

  /// The username of the user
  final String username;

  /// The password of the user, is an empty string if the user is `public`.
  final String password;

  @override
  String toString() {
    return 'Client($username, $password)';
  }
}
