import 'package:s3i_flutter/src/exceptions/parse_exception.dart';

/// Exception thrown when a json document could not be parsed correctly.
class InvalidMesssageJsonValue extends ParseException {
  /// Creates an [InvalidMesssageJsonValue] with the given [message] and
  /// the encoded [jsonDump].
  InvalidMesssageJsonValue(String message, this.jsonDump) : super(message);

  /// The json document which triggers the parsing error (or a subset of it).
  String jsonDump;

  @override
  String toString() {
    return 'InvalidMesssageJsonValue: $errorMessage | Try parsing: $jsonDump';
  }
}
